Index: /main/trunk/greenstone2/bin/script/gti.pl
===================================================================
--- /main/trunk/greenstone2/bin/script/gti.pl	(revision 24626)
+++ /main/trunk/greenstone2/bin/script/gti.pl	(revision 24627)
@@ -1614,56 +1591,56 @@
     my $target_file_key_to_gti_comment_mapping = shift(@_);
     my $target_language_code = shift(@_);  # Not used
-
+	
     # Build a mapping from chunk key to source file line, and from source file line to chunk key
     my %source_file_key_to_line_mapping = &build_key_to_line_mapping_for_greenstone_xml(@source_file_lines);
     my %source_file_line_to_key_mapping = ();
     foreach my $chunk_key (keys(%source_file_key_to_line_mapping)) {
-	$source_file_line_to_key_mapping{$source_file_key_to_line_mapping{$chunk_key}} = $chunk_key;
-    }
-
+		$source_file_line_to_key_mapping{$source_file_key_to_line_mapping{$chunk_key}} = $chunk_key;
+    }
+	
     # Write the new target file
     my $target_file_path = &util::filename_cat($gsdl_root_directory, $target_file);
     if (!open(TARGET_FILE, ">$target_file_path")) {
-	&throw_fatal_error("Could not write target file $target_file_path.");
-    }
-
+		&throw_fatal_error("Could not write target file $target_file_path.");
+    }
+	
     # Model the new target file on the source file, with the target file translations
     my $source_file_line_number = 0;
     foreach my $line_key (sort sort_by_line (keys(%source_file_line_to_key_mapping))) {
- 	# Fill in the gaps before this chunk starts
- 	my $source_file_chunk_starting_line_number = (split(/-/, $line_key))[0];
- 	my $source_file_chunk_finishing_line_number = (split(/-/, $line_key))[1];
- 	while ($source_file_line_number < $source_file_chunk_starting_line_number) {
- 	    print TARGET_FILE $source_file_lines[$source_file_line_number];
- 	    $source_file_line_number++;
- 	}
- 	$source_file_line_number = $source_file_chunk_finishing_line_number + 1;
-
-	my $chunk_key = $source_file_line_to_key_mapping{$line_key};
-	my $source_file_chunk_text = $source_file_key_to_text_mapping->{$chunk_key};
-	my $target_file_chunk_text = $target_file_key_to_text_mapping->{$chunk_key} || "";
-	$target_file_chunk_text =~ s/(\n)*$//g;
-
-	# If no translation exists for this chunk, show this, and move on
-	if ($source_file_chunk_text ne "" && $target_file_chunk_text eq "") {
-	    print TARGET_FILE "<!-- Missing translation: $chunk_key -->\n";
-	    next;
-	}
-
-	print TARGET_FILE "<Text id=\"$chunk_key\">$target_file_chunk_text</Text>";
-	if ($target_file_key_to_gti_comment_mapping->{$chunk_key}) {
-	    my $chunk_gti_comment = $target_file_key_to_gti_comment_mapping->{$chunk_key};
-	    $chunk_gti_comment =~ s/^Updated //;
-	    print TARGET_FILE "<Updated date=\"" . $chunk_gti_comment . "\"\/>";
-	}
-	print TARGET_FILE "\n";
-    }
-
+		# Fill in the gaps before this chunk starts
+		my $source_file_chunk_starting_line_number = (split(/-/, $line_key))[0];
+		my $source_file_chunk_finishing_line_number = (split(/-/, $line_key))[1];
+		while ($source_file_line_number < $source_file_chunk_starting_line_number) {
+			print TARGET_FILE $source_file_lines[$source_file_line_number];
+			$source_file_line_number++;
+		}
+		$source_file_line_number = $source_file_chunk_finishing_line_number + 1;
+		
+		my $chunk_key = $source_file_line_to_key_mapping{$line_key};
+		my $source_file_chunk_text = $source_file_key_to_text_mapping->{$chunk_key};
+		my $target_file_chunk_text = $target_file_key_to_text_mapping->{$chunk_key} || "";
+		$target_file_chunk_text =~ s/(\n)*$//g;
+		
+		# If no translation exists for this chunk, show this, and move on
+		if ($source_file_chunk_text ne "" && $target_file_chunk_text eq "") {
+			print TARGET_FILE "<!-- Missing translation: $chunk_key -->\n";
+			next;
+		}
+		
+		print TARGET_FILE "<Text id=\"$chunk_key\">$target_file_chunk_text</Text>";
+		if ($target_file_key_to_gti_comment_mapping->{$chunk_key}) {
+			my $chunk_gti_comment = $target_file_key_to_gti_comment_mapping->{$chunk_key};
+			$chunk_gti_comment =~ s/^Updated //;
+			print TARGET_FILE "<Updated date=\"" . $chunk_gti_comment . "\"\/>";
+		}
+		print TARGET_FILE "\n";
+    }
+	
     # Fill in the end of the file
     while ($source_file_line_number < scalar(@source_file_lines)) {
-	print TARGET_FILE $source_file_lines[$source_file_line_number];
-	$source_file_line_number++;
-    }
-
+		print TARGET_FILE $source_file_lines[$source_file_line_number];
+		$source_file_line_number++;
+    }
+	
     close(TARGET_FILE);
 }
@@ -1678,10 +1655,10 @@
     my $target_language_code = lc(shift(@_));
     my $translation_file_key = lc(shift(@_));
-
+	
     # Check that the necessary arguments were supplied
     if (!$target_language_code) {
-	&throw_fatal_error("Missing command argument.");
-    }
-
+		&throw_fatal_error("Missing command argument.");
+    }
+	
     # Get (and check) the translation configuration
     # my ($source_file_dir, $target_file, $translation_file_type) = &get_translation_configuration($target_language_code, $translation_file_key);
@@ -1691,10 +1668,10 @@
     my %source_files_key_to_last_update_date_mapping = ();
     my %target_files_key_to_last_update_date_mapping = ();
-
+	
     &build_gs3_configuration($target_language_code, \%source_files_key_to_text_mapping, \%target_files_key_to_text_mapping, \%source_files_key_to_last_update_date_mapping, \%target_files_key_to_last_update_date_mapping);
-
+	
     &log_message("Total number of source chunks: " . scalar(keys(%source_files_key_to_text_mapping)));
     &log_message("Total number of target chunks: " . scalar(keys(%target_files_key_to_text_mapping)));
-
+	
     my $xml_response = &create_xml_response_for_all_chunks($translation_file_key, "", \%source_files_key_to_text_mapping, \%target_files_key_to_text_mapping, \%source_files_key_to_last_update_date_mapping, \%target_files_key_to_last_update_date_mapping);   
     return $xml_response;
@@ -1713,5 +1690,5 @@
     # Check that the necessary arguments were supplied
     if (!$target_language_code || !$translation_file_key) {
-	&throw_fatal_error("Missing command argument.");
+		&throw_fatal_error("Missing command argument.");
     }
     
@@ -1720,7 +1697,7 @@
     my %source_files_key_to_last_update_date_mapping = ();
     my %target_files_key_to_last_update_date_mapping = ();
-
+	
     &build_gs3_configuration($target_language_code, \%source_files_key_to_text_mapping, \%target_files_key_to_text_mapping, 
-			     \%source_files_key_to_last_update_date_mapping, \%target_files_key_to_last_update_date_mapping);
+	\%source_files_key_to_last_update_date_mapping, \%target_files_key_to_last_update_date_mapping);
     
     # Determine the target file chunks requiring translation
@@ -1730,10 +1707,10 @@
     &log_message("Total number of target chunks requiring translation: " . scalar(@target_files_keys_requiring_translation));
     &log_message("Total number of target chunks requiring updating: " . scalar(@target_files_keys_requiring_updating));
-
+	
     my $xml_response = &create_xml_response_for_chunks_requiring_work($translation_file_key, "", scalar(keys(%source_files_key_to_text_mapping)),
-								      \@target_files_keys_requiring_translation, \@target_files_keys_requiring_updating,
-								      $num_chunks_to_return, \%source_files_key_to_text_mapping, \%target_files_key_to_text_mapping,
-								      \%source_files_key_to_last_update_date_mapping, \%target_files_key_to_last_update_date_mapping);
-   
+	\@target_files_keys_requiring_translation, \@target_files_keys_requiring_updating,
+	$num_chunks_to_return, \%source_files_key_to_text_mapping, \%target_files_key_to_text_mapping,
+	\%source_files_key_to_last_update_date_mapping, \%target_files_key_to_last_update_date_mapping);
+	
     return $xml_response;
 }
@@ -1748,44 +1725,44 @@
     my $source_file_directory = "greenstone3";
     my $translation_file_type = "resource_bundle";
-
+	
     foreach my $interface_file_key (@gs3_interface_files) {
-
-	&log_message("Greenstone 3 interface file: " . $interface_file_key);
-
-	# Parse the source language and target language files
-	my $source_file = &util::filename_cat($source_file_directory, $interface_file_key.".properties");
-	my @source_file_lines = &read_file_lines(&util::filename_cat($gsdl_root_directory, $source_file));
-	my %source_file_key_to_line_mapping = &build_key_to_line_mapping(\@source_file_lines, $translation_file_type);
-	my %source_file_key_to_text_mapping = &build_key_to_text_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
-	my %source_file_key_to_gti_comment_mapping = &build_key_to_gti_comment_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);	
-	
-	my $target_file = &util::filename_cat($source_file_directory, $interface_file_key."_".$target_language_code.".properties");
-	my @target_file_lines = &read_file_lines(&util::filename_cat($gsdl_root_directory, $target_file));
-	my %target_file_key_to_line_mapping = &build_key_to_line_mapping(\@target_file_lines, $translation_file_type);
-	my %target_file_key_to_text_mapping = &build_key_to_text_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
-	my %target_file_key_to_gti_comment_mapping = &build_key_to_gti_comment_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
-
-
-	# Filter out any automatically translated chunks
-	foreach my $chunk_key (keys(%source_file_key_to_line_mapping)) {
-	    if (&is_chunk_automatically_translated($chunk_key, $translation_file_type)) {
-		delete $source_file_key_to_line_mapping{$chunk_key};
-		delete $target_file_key_to_line_mapping{$chunk_key};
-	    }
-	}
-
-	&log_message("Number of source chunks: " . scalar(keys(%source_file_key_to_text_mapping)));
-	&log_message("Number of target chunks: " . scalar(keys(%target_file_key_to_text_mapping)));
-
-	foreach my $chunk_key (keys(%source_file_key_to_text_mapping)) {
-	    my $global_chunk_key = "$interface_file_key.$chunk_key";
-	    $source_files_key_to_text_mapping->{$global_chunk_key} = $source_file_key_to_text_mapping{$chunk_key};
-	    $source_files_key_to_gti_comment_mapping->{$global_chunk_key} = $source_file_key_to_gti_comment_mapping{$chunk_key};
-
-	    if (defined $target_file_key_to_text_mapping{$chunk_key}) {
-		$target_files_key_to_text_mapping->{$global_chunk_key} = $target_file_key_to_text_mapping{$chunk_key};
-		$target_files_key_to_gti_comment_mapping->{$global_chunk_key} = $target_file_key_to_gti_comment_mapping{$chunk_key};
-	    }
-	}	
+		
+		&log_message("Greenstone 3 interface file: " . $interface_file_key);
+		
+		# Parse the source language and target language files
+		my $source_file = &util::filename_cat($source_file_directory, $interface_file_key.".properties");
+		my @source_file_lines = &read_file_lines(&util::filename_cat($gsdl_root_directory, $source_file));
+		my %source_file_key_to_line_mapping = &build_key_to_line_mapping(\@source_file_lines, $translation_file_type);
+		my %source_file_key_to_text_mapping = &build_key_to_text_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
+		my %source_file_key_to_gti_comment_mapping = &build_key_to_gti_comment_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);	
+		
+		my $target_file = &util::filename_cat($source_file_directory, $interface_file_key."_".$target_language_code.".properties");
+		my @target_file_lines = &read_file_lines(&util::filename_cat($gsdl_root_directory, $target_file));
+		my %target_file_key_to_line_mapping = &build_key_to_line_mapping(\@target_file_lines, $translation_file_type);
+		my %target_file_key_to_text_mapping = &build_key_to_text_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
+		my %target_file_key_to_gti_comment_mapping = &build_key_to_gti_comment_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
+		
+		
+		# Filter out any automatically translated chunks
+		foreach my $chunk_key (keys(%source_file_key_to_line_mapping)) {
+			if (&is_chunk_automatically_translated($chunk_key, $translation_file_type)) {
+				delete $source_file_key_to_line_mapping{$chunk_key};
+				delete $target_file_key_to_line_mapping{$chunk_key};
+			}
+		}
+		
+		&log_message("Number of source chunks: " . scalar(keys(%source_file_key_to_text_mapping)));
+		&log_message("Number of target chunks: " . scalar(keys(%target_file_key_to_text_mapping)));
+		
+		foreach my $chunk_key (keys(%source_file_key_to_text_mapping)) {
+			my $global_chunk_key = "$interface_file_key.$chunk_key";
+			$source_files_key_to_text_mapping->{$global_chunk_key} = $source_file_key_to_text_mapping{$chunk_key};
+			$source_files_key_to_gti_comment_mapping->{$global_chunk_key} = $source_file_key_to_gti_comment_mapping{$chunk_key};
+			
+			if (defined $target_file_key_to_text_mapping{$chunk_key}) {
+				$target_files_key_to_text_mapping->{$global_chunk_key} = $target_file_key_to_text_mapping{$chunk_key};
+				$target_files_key_to_gti_comment_mapping->{$global_chunk_key} = $target_file_key_to_gti_comment_mapping{$chunk_key};
+			}
+		}	
     }
 }
@@ -1800,12 +1777,12 @@
     
     my @sorted_chunk_keys = sort (keys(%$source_file_key_to_text_mapping));
-
+	
     my %translated_interface_file_keys = ();
     foreach my $chunk_key (keys(%$target_file_key_to_text_mapping)) {
-	$chunk_key =~ /^([^\.]+)?\.(.*)$/;
-	if (!defined $translated_interface_file_keys{$1}) {
-	    &log_message("Updated interface file: " . $1);	
-	    $translated_interface_file_keys{$1}="";
-	}
+		$chunk_key =~ /^([^\.]+)?\.(.*)$/;
+		if (!defined $translated_interface_file_keys{$1}) {
+			&log_message("Updated interface file: " . $1);	
+			$translated_interface_file_keys{$1}="";
+		}
     }
     &log_message("Updated interface files: " . scalar(keys(%translated_interface_file_keys)));
@@ -1814,52 +1791,52 @@
     
     foreach my $interface_file_key (keys(%translated_interface_file_keys)) {
-	
-	# Build a mapping from chunk key to source file line, and from source file line to chunk key
-	my $source_file = &util::filename_cat($source_file_directory, "$interface_file_key.properties");
-	my @source_file_lines = &read_file_lines(&util::filename_cat($gsdl_root_directory, $source_file));
-	my %source_file_key_to_line_mapping = &build_key_to_line_mapping_for_resource_bundle(@source_file_lines);
-	my %source_file_line_to_key_mapping = ();
-	foreach my $chunk_key (keys(%source_file_key_to_line_mapping)) {
-	    $source_file_line_to_key_mapping{$source_file_key_to_line_mapping{$chunk_key}} = $chunk_key;
-	}
-	
-	# Write the new target file
-	my $target_file = &util::filename_cat($source_file_directory, $interface_file_key . "_" . $target_language_code . ".properties");
-	my $target_file_path = &util::filename_cat($gsdl_root_directory, $target_file);
-	if (!open(TARGET_FILE, ">$target_file_path")) {
-	    &throw_fatal_error("Could not write target file $target_file_path.");
-	}
-
-	# Model the new target file on the source file, with the target file translations
-	my $source_file_line_number = 0;
-	foreach my $line_key (sort sort_by_line (keys(%source_file_line_to_key_mapping))) {
-	    # Fill in the gaps before this chunk starts
-	    my $source_file_chunk_starting_line_number = (split(/-/, $line_key))[0];
-	    my $source_file_chunk_finishing_line_number = (split(/-/, $line_key))[1];
-	    while ($source_file_line_number < $source_file_chunk_starting_line_number) {
-		print TARGET_FILE $source_file_lines[$source_file_line_number];
-		$source_file_line_number++;
-	    }
-	    $source_file_line_number = $source_file_chunk_finishing_line_number + 1;
-
-	    my $chunk_key = $source_file_line_to_key_mapping{$line_key};
-	    my $global_chunk_key = "$interface_file_key.$chunk_key";
-	    my $source_file_chunk_text = $source_file_key_to_text_mapping->{$global_chunk_key};
-	    my $target_file_chunk_text = $target_file_key_to_text_mapping->{$global_chunk_key} || "";
-
-	    # If no translation exists for this chunk, show this, and move on
-	    if ($source_file_chunk_text ne "" && $target_file_chunk_text eq "") {
-		print TARGET_FILE "# -- Missing translation: $chunk_key\n";
-		next;
-	    }
-
-	    print TARGET_FILE "$chunk_key:$target_file_chunk_text";
-	    if ($target_file_key_to_gti_comment_mapping->{$global_chunk_key}) {
-		print TARGET_FILE "  # " . $target_file_key_to_gti_comment_mapping->{$global_chunk_key};
-		}
-	    print TARGET_FILE "\n";
-	}
-
-	close(TARGET_FILE);	
+		
+		# Build a mapping from chunk key to source file line, and from source file line to chunk key
+		my $source_file = &util::filename_cat($source_file_directory, "$interface_file_key.properties");
+		my @source_file_lines = &read_file_lines(&util::filename_cat($gsdl_root_directory, $source_file));
+		my %source_file_key_to_line_mapping = &build_key_to_line_mapping_for_resource_bundle(@source_file_lines);
+		my %source_file_line_to_key_mapping = ();
+		foreach my $chunk_key (keys(%source_file_key_to_line_mapping)) {
+			$source_file_line_to_key_mapping{$source_file_key_to_line_mapping{$chunk_key}} = $chunk_key;
+		}
+		
+		# Write the new target file
+		my $target_file = &util::filename_cat($source_file_directory, $interface_file_key . "_" . $target_language_code . ".properties");
+		my $target_file_path = &util::filename_cat($gsdl_root_directory, $target_file);
+		if (!open(TARGET_FILE, ">$target_file_path")) {
+			&throw_fatal_error("Could not write target file $target_file_path.");
+		}
+		
+		# Model the new target file on the source file, with the target file translations
+		my $source_file_line_number = 0;
+		foreach my $line_key (sort sort_by_line (keys(%source_file_line_to_key_mapping))) {
+			# Fill in the gaps before this chunk starts
+			my $source_file_chunk_starting_line_number = (split(/-/, $line_key))[0];
+			my $source_file_chunk_finishing_line_number = (split(/-/, $line_key))[1];
+			while ($source_file_line_number < $source_file_chunk_starting_line_number) {
+				print TARGET_FILE $source_file_lines[$source_file_line_number];
+				$source_file_line_number++;
+			}
+			$source_file_line_number = $source_file_chunk_finishing_line_number + 1;
+			
+			my $chunk_key = $source_file_line_to_key_mapping{$line_key};
+			my $global_chunk_key = "$interface_file_key.$chunk_key";
+			my $source_file_chunk_text = $source_file_key_to_text_mapping->{$global_chunk_key};
+			my $target_file_chunk_text = $target_file_key_to_text_mapping->{$global_chunk_key} || "";
+			
+			# If no translation exists for this chunk, show this, and move on
+			if ($source_file_chunk_text ne "" && $target_file_chunk_text eq "") {
+				print TARGET_FILE "# -- Missing translation: $chunk_key\n";
+				next;
+			}
+			
+			print TARGET_FILE "$chunk_key:$target_file_chunk_text";
+			if ($target_file_key_to_gti_comment_mapping->{$global_chunk_key}) {
+				print TARGET_FILE "  # " . $target_file_key_to_gti_comment_mapping->{$global_chunk_key};
+			}
+			print TARGET_FILE "\n";
+		}
+		
+		close(TARGET_FILE);	
     }           
 }
